
/*
 Copyright 1999 by Digi International (www.digi.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED; without even the 
 implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 *	DXB API for the Eye Quality Monitoring device
 *
 *	$Id: eqm.h,v 1.6 1999/09/03 15:27:18 dickl Exp $
 */
#ifndef _EQM_H
#define _EQM_H

/*
 *	The name of the DXB device to open.  Note that we crrently allow
 *	only one EQM tap device to be open at a time.  I was lazy.
 *	Saves minor device numbers, too.  Hence, there is no data
 *	portion to the open message.
 */
#define	EQM_NAME	"EQM"

/*
 *	Once open, the EQM is quiescent (does not send X,Y coords) until
 *	you write a control message to it.
 *
 *	As usual, I have avoided using evil ioctl's to control this.
 *	The write mechanism allows you to use a script to control the
 *	device.  E.G. for Unix types:
 *		cat /dev/dm/eqm > file &
 *		echo "eqm binary 0 100 0" > /dev/dm/eqm
 *
 *	The following messages are supported:
 *
 *	pause <flag>
 *		If <flag> is 0, pause sampling temporarily.  If <flag> is 1,
 *		resume sampling.
 *
 *	stop
 *		Stop sampling and cause EOF to occur.
 *
 *	eqm <format> <chan> <rate> <nsamples>
 *		Select CSC instance <chan> for EQM sampling.  Sample the
 *		EQM at <rate> samples per second (max 1000).
 *		Begin sending sample data to the host.  If <nsamples> is
 *		non-zero, stop sending data after <nsamples>, else send
 *		data forever.  Send the data in <format> (ascii or binary).
 *
 *	pcm <format> <chan> <rate> <nsamples>
 *		Same as eqm command, but for PCM modulations.
 *
 *	xy <xaddr> <yaddr> <format> <chan> <rate> <nsamples>
 *		Collect arbitrary sample from DSP addresses xaddr and yaddr.
 *
 *	All numbers may be in decimal or hex (prefixed with 0x).
 */

#endif
