/*****************************************************************************
 * Copyright (c) 1988-95 Digi International Inc., All Rights Reserved
 * 
 * This  software  contains  proprietary  and  confidential   information   of
 * Digi International  Inc.   By  accepting  transfer  of this copy, Recipient
 * agrees to retain this software in  confidence,  to  prevent  disclosure  to
 * others,  and  to make no  use of this software other than that for which it
 * was delivered.  This is an unpublished copyright work  Digi   International
 * Inc.    Except   as   permitted   by  federal  law,  17 USC 117, copying is
 * strictly prohibited.
 * 
 * Digi  International  Inc.  CONFIDENTIAL  -   (Digi    International    Inc.
 * Confidential  when   combined   with   the   aggregated  modules  for  this
 * product) OBJECT CODE ONLY SOURCE MATERIALS
 * 
 * (C) COPYRIGHT Digi International Inc. 1995
 * 
 * All Rights Reserved
 * 
 * US   Government   Users   Restricted   Rights   -   Use,   duplication   or
 * disclosure  restricted by GSA ADP Schedule Contract with Digi International
 * Inc.
 * 
 *****************************************************************************/

/*
 * $Id: lmsi.h,v 1.2 1999/05/14 21:02:35 gary Exp $
 *
 * Copyright (c) 1993 Spider Systems Limited
 *
 * This Source Code is furnished under Licence, and may not be
 * copied or distributed without express written agreement.
 *
 * All rights reserved.  Made in Scotland.
 *
 * Authors: Angus Grossart
 *
 * lmsi.h of snet module
 *
 * SpiderISDN
 * Release 3.0.0 94/12/20
 * 
 * SpiderISDN Release 3 - Official Release.
 */

/* 
 * lmsi.h header for Lower MIB Interface
 * =====================================
 * This header defines all the necessary structures for communication between
 * the Lower MIB Interface and the underlying protocol resources.
 */

#ifndef _SYS_SNET_LMSI_
#define _SYS_SNET_LMSI_

#define LMSI_MSG           ('E'<<8)

/*
 *  The STREAMS M_IOCTL upstream and downstream primitive type.
 *  A request is distinguished from an acknowledgement by the M_IOCTL
 *  or M_IOCACK type.
 */
#define LMSI_CREATE	(LMSI_MSG + 1) /* create an object instance	*/ 
#define LMSI_DELETE	(LMSI_MSG + 2) /* delete an object instance	*/
#define LMSI_GET	(LMSI_MSG + 3) /* get one or more instance attributes */
#define LMSI_SET	(LMSI_MSG + 4) /* set one or more instance attributes */
#define LMSI_EVENT	(LMSI_MSG + 5) /* object generated event type */
#define LMSI_MGET	(LMSI_MSG + 6) /* table retrievals */
#define LMSI_GETNEXT	(LMSI_MSG + 7) /* get next instance */
#define LMSI_TRAP	(LMSI_MSG + 8) /* object generated trap type */
#define LMSI_TESTSET	(LMSI_MSG + 9) /* testset operation */

#define LMSI_BIND	(LMSI_MSG +10) /* future use with LMSI switch driver */
#define LMSI_CONNECT	(LMSI_MSG +11) /* future use with LMSI switch driver */


/* The timeout period for LMSI M_IOCTL requests -15 seconds	*/
#define LMSI_TIMEOUT 0 

#ifdef MAXIOCBSZ /* Defined in sys/stream.h */
#define LMSI_MAX_SIZE 	MAXIOCBSZ
#else
#define LMSI_MAX_SIZE	1024	/* Maximum STREAMS LMSI data fragment size */
#endif

#define LMSI_STRMS	1 	/* STREAMS object */

#endif
